#include "tcp.h"
//-------------------------------------------------------------
static const char *TAG = "tcp";
//-------------------------------------------------------------
typedef struct struct_client_socket_t {
  struct sockaddr_in cliaddr;
  socklen_t sockaddrsize;
  int accept_sock;
  uint16_t y_pos;
} struct_client_socket;
struct_client_socket client_socket01;
//-------------------------------------------------------------
typedef struct
{
  unsigned char y_pos;
  unsigned char x_pos;
  char *str;
} qLCDData;
//------------------------------------------------
xQueueHandle lcd_string_queue = NULL, xQueueClose = NULL, xQueueCloseAsk = NULL;;
//------------------------------------------------
void vLCDTask(void* arg)
{
  BaseType_t xStatus;
  qLCDData xReceivedData;
  for(;;) {
    xStatus = xQueueReceive(lcd_string_queue, &xReceivedData, 10000 /portTICK_RATE_MS);
    if (xStatus == pdPASS)
    {
      LCD_SetPos(xReceivedData.x_pos,xReceivedData.y_pos);
      LCD_String(xReceivedData.str);
    }
  }
}
//------------------------------------------------
static void client_socket_task(void *pvParameters)
{
  char str1[21];
  int ret, accept_sock;
  qLCDData xLCDData;
  struct_client_socket *arg_client_socket;
  arg_client_socket = (struct_client_socket*) pvParameters;
  struct sockaddr_in cliaddr;
  socklen_t sockaddrsize;
  int buflen = 150;
  char data_buffer[22] = {};
  xLCDData.y_pos = arg_client_socket->y_pos;
  xLCDData.str = str1;
  accept_sock = arg_client_socket->accept_sock;
  cliaddr = arg_client_socket->cliaddr;
  sockaddrsize  = arg_client_socket->sockaddrsize;
  while(1)
  {
    ret = recvfrom( accept_sock,data_buffer, buflen, 0, (struct sockaddr *)&cliaddr, &sockaddrsize);
    if(ret > 0)
    {
      data_buffer[ret-1] = 0;
    }
    if(strncmp(data_buffer, "-c", 2) == 0)
    {
      close(accept_sock);
      vTaskDelete(NULL);
    }
    if(strcmp(data_buffer, "\r\n") != 0)
    {
      strcpy(str1, data_buffer);
      for(unsigned char i=ret-2;i<20;i++)   {str1[i]=' ';}
      str1[20] = 0;
      xQueueSendToBack(lcd_string_queue, &xLCDData, 0);
      strcat(data_buffer,"\r\n");
      ESP_LOGI(TAG, "Socket %d: %s", accept_sock, data_buffer);
      sendto(accept_sock,data_buffer,strlen((char*)data_buffer),0,(struct sockaddr *)&cliaddr, sockaddrsize);
    }
  }
}
//------------------------------------------------
void tcp_task(void *pvParameters)
{
  TaskHandle_t xLCDTaskHandle = NULL;
  int sockfd, accept_sock;
  unsigned char y_pos = 0;
  socklen_t sockaddrsize;
  qLCDData xLCDData;
  char str1[21];
  xLCDData.y_pos = 1;
  xLCDData.str = str1;
  struct sockaddr_in servaddr, cliaddr;
  lcd_string_queue = xQueueCreate(10, sizeof(qLCDData));
  xQueueClose = xQueueCreate(10, sizeof(unsigned char));
  xQueueCloseAsk = xQueueCreate(10, sizeof(unsigned char));
  xTaskCreate(vLCDTask, "vLCDTask", 2048, NULL, 2, &xLCDTaskHandle);
  ESP_LOGI(TAG, "Create socket...\n");
  if ( (sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_IP)) < 0 ) {
    ESP_LOGE(TAG, "socket not created\n");
    vTaskDelete(NULL);
  }
  ESP_LOGI(TAG, "Socket created");
  memset(&servaddr, 0, sizeof(servaddr));
  //   
  servaddr.sin_family    = AF_INET; // IPv4
  servaddr.sin_addr.s_addr = INADDR_ANY;
  servaddr.sin_port = htons(CONFIG_SERVER_PORT);
  //    
  if (bind(sockfd, (const struct sockaddr *)&servaddr,  sizeof(struct sockaddr_in)) < 0 )
  {
    ESP_LOGE(TAG, "socket not binded\n");
    vTaskDelete(xLCDTaskHandle);
    vQueueDelete(lcd_string_queue);
    vTaskDelete(NULL);
  }
  ESP_LOGI(TAG, "socket was binded\n");
  listen(sockfd, 5);
  while(1)
  {
    memset(&cliaddr, 0, sizeof(cliaddr));
    accept_sock = accept(sockfd, (struct sockaddr *)&cliaddr, (socklen_t *)&sockaddrsize);
    printf("socket: %d\n", accept_sock);
    if(accept_sock >= 0)
    {
      client_socket01.accept_sock = accept_sock;
      client_socket01.cliaddr = cliaddr;
      client_socket01.sockaddrsize = sockaddrsize;
      client_socket01.y_pos = y_pos%4;
      xTaskCreate(client_socket_task, "client_socket_task", 4096, (void*)&client_socket01, 5, NULL);
      y_pos++;
    }
  }
  close(sockfd);
  sprintf(str1, "Disonnected");
  xQueueSendToBack(lcd_string_queue, &xLCDData, 0);
  vTaskDelay(2000 / portTICK_RATE_MS);
  vTaskDelete(xLCDTaskHandle);
  vQueueDelete(lcd_string_queue);
  vTaskDelete(NULL);
}
//-------------------------------------------------------------
